# The Qubes OS Project, https://www.qubes-os.org
#
# This library is free software; you can redistribute it and/or
# modify it under the terms of the GNU Lesser General Public
# License as published by the Free Software Foundation; either
# version 2.1 of the License, or (at your option) any later version.
#
# This library is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
# Lesser General Public License for more details.
#
# You should have received a copy of the GNU Lesser General Public
# License along with this library; if not, see <https://www.gnu.org/licenses/>.

Name:		qubes-rpm-oxide
Version:	0.2.2
Release:	1%{dist}
Summary:	RPM Canonicalization

Group:		Qubes
Vendor:		Invisible Things Lab
License:	MIT OR Apache-2.0
URL:		https://www.qubes-os.org

BuildRequires:  rust
BuildRequires:  cargo
BuildRequires:  rpm-devel
BuildRequires:  rust-debugger-common

Requires:       rpm >= 4.14.2.1-4

Source0: %{name}-%{version}.tar.gz

%description
RPM canonicalization and verification tools

%prep
%setup -q
%build
RUSTFLAGS='-Cdebuginfo=2 -Clink-arg=-z,relro,-z,now' RUSTC_BOOTSTRAP=1 cargo build --all-features --release
%install
install -D -m 0755 -- target/release/rpmcanon "$RPM_BUILD_ROOT"/%_bindir/rpmcanon
%check
RUSTC_BOOTSTRAP=1 cargo test --all-features --release -- --test-threads=1
%clean
rm -rf "$RPM_BUILD_ROOT" '%{name}-%{version}'
%files
%attr(755,root,root) /usr/bin/rpmcanon
%changelog
* Mon Apr 26 2021 Qubes OS Team <qubes-devel@googlegroups.com>
- For complete changelog see: https://github.com/QubesOS/qubes-rpm-oxide.git

* Mon Apr 26 2021 Marek Marczykowski-Górecki <marmarek@invisiblethingslab.com> - 859ee52
- version 0.2.2

* Mon Apr 26 2021 Demi Marie Obenour <demi@invisiblethingslab.com> - 0da8ae2
- Input packet format must not affect serialized output

* Fri Apr 23 2021 Marek Marczykowski-Górecki <marmarek@invisiblethingslab.com> - e7c67e6
- version 0.2.1

* Fri Apr 23 2021 Marek Marczykowski-Górecki <marmarek@invisiblethingslab.com> - 9d17d92
- ci: add config

* Fri Apr 23 2021 Demi Marie Obenour <demi@invisiblethingslab.com> - 677b8ef
- Revert "Check Cargo.lock into git"

* Thu Apr 22 2021 Demi Marie Obenour <demi@invisiblethingslab.com> - 5c182f1
- Check Cargo.lock into git

* Thu Apr 22 2021 Demi Marie Obenour <demi@invisiblethingslab.com> - f14384b
- Move data files to subdirectory

* Thu Apr 22 2021 Demi Marie Obenour <demi@invisiblethingslab.com> - b6e983e
- .gitignore generated packages

* Thu Apr 22 2021 Demi Marie Obenour <demi@invisiblethingslab.com> - 2fdca35
- Bump version to 0.2.0

* Thu Apr 22 2021 Demi Marie Obenour <demi@invisiblethingslab.com> - 85af681
- Add both SHA256 and SHA1 header digests

* Thu Apr 22 2021 Demi Marie Obenour <demi@invisiblethingslab.com> - f744f4f
- Fix unused mut warning

* Thu Apr 22 2021 Demi Marie Obenour <demi@invisiblethingslab.com> - b8902fc
- Emit size tags

* Thu Apr 22 2021 Demi Marie Obenour <demi@invisiblethingslab.com> - e36c122
- rpm-writer: support U16/U32/U64 tag data entries

* Thu Apr 22 2021 Demi Marie Obenour <demi@invisiblethingslab.com> - fb549e5
- Use SHA1 instead of SHA256 for the header digest

* Thu Apr 22 2021 Demi Marie Obenour <demi@invisiblethingslab.com> - 460fb11
- Remove the --directory option

* Thu Apr 22 2021 Demi Marie Obenour <demi@invisiblethingslab.com> - 2567bab
- Use the same kinds of OpenPGP packets as GPG

* Fri Apr 16 2021 Demi Marie Obenour <demi@invisiblethingslab.com> - 9d9381f
- Make the RPM package installable

* Fri Apr 16 2021 Demi Marie Obenour <demi@invisiblethingslab.com> - 9bc49e2
- Add qubes-builder support

* Thu Apr 15 2021 Demi Marie Obenour <demi@invisiblethingslab.com> - e9a0787
- Add the changelog to the RPM specfile

* Thu Apr 15 2021 Demi Marie Obenour <demi@invisiblethingslab.com> - 1d03fc9
- Run the test-suite single-threaded

* Thu Apr 15 2021 Demi Marie Obenour <demi@invisiblethingslab.com> - 7f5d7b4
- Avoid an RPM warning during the build

* Thu Apr 15 2021 Demi Marie Obenour <demi@invisiblethingslab.com> - 41e251c
- Replace and/or document unsafe code

* Thu Apr 15 2021 Demi Marie Obenour <demi@invisiblethingslab.com> - 5972ea6
- Re-enable little-endian code in buffer.rs

* Thu Apr 15 2021 Demi Marie Obenour <demi@invisiblethingslab.com> - 0a1a470
- Suppress warnings on various versions of Rust

* Wed Apr 14 2021 Demi Marie Obenour <demi@invisiblethingslab.com> - 02cdb91
- Strings in signature header are printable ASCII

* Wed Apr 14 2021 Demi Marie Obenour <demi@invisiblethingslab.com> - a864fde
- Fix building with qubes-builder

* Tue Apr 13 2021 Demi Marie Obenour <demi@invisiblethingslab.com> - e6071aa
- Create a usable RPM package

* Thu Apr 08 2021 Demi Marie Obenour <demi@invisiblethingslab.com> - 67fb900
- String tags may wrongfully be arrays

* Thu Apr 08 2021 Demi Marie Obenour <demi@invisiblethingslab.com> - 1421f59
- Allow and ignore signer user ID subpackets

* Thu Apr 08 2021 Demi Marie Obenour <demi@invisiblethingslab.com> - a1f540f
- Better error message for unknown subpackets

* Thu Mar 25 2021 Demi Marie Obenour <demi@invisiblethingslab.com> - ce62233
- Check that signatures are currently valid

* Thu Mar 25 2021 Demi Marie Obenour <demi@invisiblethingslab.com> - 04f7b93
- Generate MD5 hashes where needed

* Mon Mar 15 2021 Demi Marie Obenour <demi@invisiblethingslab.com> - d32b714
- Allow unknown tags in the signature header

* Mon Mar 15 2021 Demi Marie Obenour <demi@invisiblethingslab.com> - f0ed773
- Reformat and remove unused variables

* Sun Mar 14 2021 Demi Marie Obenour <demi@invisiblethingslab.com> - bc51a5e
- Move the validator module to a separate file

* Sat Mar 13 2021 Demi Marie Obenour <demi@invisiblethingslab.com> - 5afa9d0
- Remove dead code in rpmcanon

* Sat Mar 13 2021 Demi Marie Obenour <demi@invisiblethingslab.com> - 9b89518
- Remove unnecessary qualification in verify.rs

* Sat Mar 13 2021 Demi Marie Obenour <demi@invisiblethingslab.com> - 3f49c68
- Mass replace: allow_sha1_sha224 → allow_weak_hashes

* Sat Mar 13 2021 Demi Marie Obenour <demi@invisiblethingslab.com> - 3d059be
- Add a bunch of tests for the verification code

* Sat Mar 13 2021 Demi Marie Obenour <demi@invisiblethingslab.com> - cc1c996
- Treat EACCES the same as EPERM

* Sat Mar 13 2021 Demi Marie Obenour <demi@invisiblethingslab.com> - 1ff02fc
- Remove an unused import

* Sat Mar 13 2021 Demi Marie Obenour <demi@invisiblethingslab.com> - 06af560
- Add a comment explaining the header prelude

* Sat Mar 13 2021 Demi Marie Obenour <demi@invisiblethingslab.com> - 389da43
- Add a proper, tested cryptographic validator API

* Sat Mar 13 2021 Demi Marie Obenour <demi@invisiblethingslab.com> - 4295da6
- Fix documentation of `openpgp-parser`

* Fri Mar 12 2021 Demi Marie Obenour <demi@invisiblethingslab.com> - efec656
- Fix a silly compilation error

* Fri Mar 12 2021 Demi Marie Obenour <demi@invisiblethingslab.com> - 33f82f1
- Add NUL-termination checks

* Tue Mar 09 2021 Demi Marie Obenour <demi@invisiblethingslab.com> - 3e7472d
- Only open an existing file if it is /dev/null

* Tue Mar 09 2021 Demi Marie Obenour <demi@invisiblethingslab.com> - 9ce0827
- Streaming support

* Tue Mar 09 2021 Demi Marie Obenour <demi@invisiblethingslab.com> - 8d2f2c1
- Improve signature verification API

* Tue Mar 09 2021 Demi Marie Obenour <demi@invisiblethingslab.com> - 5c05402
- Atomically write output files

